

library(RandomFields)
#library(deldir) 
library(randtoolbox)
library(GPfit)
library(geoR)
library(lhs)
library(flexclust)

mydim = 2
m = 1 # number of simulations for each run
m1 = 1 # number of runs
n1 = 5000
mynu = 1.5
mysup = 1:m
myfill = matrix(halton(n1, dim = mydim), ncol = 2)
myh =1:m1
mysss = 1:m1



myfillDistance = function(myX,myL){
  myf = 1:myL
  for(j in 1:myL){
    myf[j] = min(rowSums((myfill[j,] - myX)^2))
  }
  return(max(myf))
}


for(j in 1:m1){
  n2 = 500 * j # number of design points
  myXX = maximinLHS(n=n2, k=mydim)
  myh[j] = myfillDistance(myXX,n1)
  myPreX <- seq(0, 1, length.out = 101)
  myPreY <- seq(0, 1, length.out = 101) # prediction points
  d1 <- expand.grid(x = myPreX, y = myPreY) # gridpoints
  mycombineX <- c(myXX[,1],d1$x)
  mycombineY <- c(myXX[,2],d1$y)
  myprey <- c(d1$y)
  
  # K <- matrix(data = 1, nrow = n2, ncol = n2)
  
  for(i in 1:m){
    # first we simulate some random values on design myXX
    sim2 <- RMmatern(mynu) # model is Matern kernel
    myfirstData <- RFsimulate(model = sim2, x=mycombineX, y=mycombineY, grid=FALSE)
    # next we fit our data
    
    # compute kernel matrix
    K <- matern(u = dist2(myXX,myXX), phi = 1/sqrt(2*mynu), kappa = mynu)
    
    # compute K^{-1}Y
    tt = solve(K, myfirstData$variable1[1:n2], tol = 0)
    
    # make prediction
    for(i3 in 1:length(d1$x)){
      r1 <- matern(u = sqrt((d1$x[i3] - myXX[,1])^2+(d1$y[i3] - myXX[,2])^2), phi = 1/sqrt(2*mynu), kappa = mynu)
      print(i3)
      myprey[i3] = t(r1) %*% tt
    }
    mysup[i] = max(abs(myprey - myfirstData$variable1[(n2 + 1):(n2 + length(d1$x))]))
  }
  mysss[j] = mean(mysup)
}
mysss
myh
